Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/WordProperty.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/WordProperty.java	(revision 2947)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/WordProperty.java	(revision 2948)
@@ -1,7 +1,12 @@
 package org.txm.searchengine.cqp.corpus;
 
+import java.io.IOException;
 import java.util.List;
 
+import org.txm.searchengine.cqp.clientExceptions.UnexpectedAnswerException;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
+import org.txm.searchengine.cqp.serverException.CqiServerError;
+
 /**
  * A CQP property at token/word level
  * 
@@ -39,9 +44,51 @@
 			if (i > 0) {
 				str += "_";
 			}
-			str += properties.get(i).getName();
+			str += properties.get(i).getFullName();
 		}
 		return "@" + str;
 	}
 	
+	public int[] cpos2Id(int[] positions) throws UnexpectedAnswerException, IOException, CqiServerError {
+		return CorpusManager.getCorpusManager().getCqiClient().cpos2Id(this.getQualifiedName(), positions);
+	}
+	
+	public String[] cpos2Str(int[] positions) throws UnexpectedAnswerException, IOException, CqiServerError {
+		return CorpusManager.getCorpusManager().getCqiClient().cpos2Str(this.getQualifiedName(), positions);
+	}
+	
+	public String[] id2Str(int[] ids) throws UnexpectedAnswerException, IOException, CqiServerError {
+		return CorpusManager.getCorpusManager().getCqiClient().id2Str(this.getQualifiedName(), ids);
+	}
+	
+	public int[] str2Id(String[] values) throws UnexpectedAnswerException, IOException, CqiServerError {
+		return CorpusManager.getCorpusManager().getCqiClient().str2Id(this.getQualifiedName(), values);
+	}
+	
+	public int[] regex2Id(String regex) throws UnexpectedAnswerException, IOException, CqiServerError {
+		return CorpusManager.getCorpusManager().getCqiClient().regex2Id(this.getQualifiedName(), regex);
+	}
+	
+	public int str2Id(String value) throws UnexpectedAnswerException, IOException, CqiServerError {
+		return CorpusManager.getCorpusManager().getCqiClient().str2Id(this.getQualifiedName(), new String[] {value})[0];
+	}
+	
+	public String getCQLTest(String value) {
+		return this.getName() + "=\"" +  CQLQuery.addBackSlash(value)+ "\"";
+	}
+	
+	public String getCQLTest(List<String> values) {
+		StringBuilder sb = new StringBuilder();
+		sb.append(this.getName() + "=\""); //$NON-NLS-1$
+		for (int i = 0 ; i < values.size() ; i++) {
+			String s = values.get(i);
+			s = CQLQuery.addBackSlash(s);
+			sb.append(s); //$NON-NLS-1$
+			if (i < values.size() -1) {
+				sb.append("|"); //$NON-NLS-1$
+			}
+		}
+		sb.append("\"");
+		return sb.toString();
+	};
 }
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/MainCorpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/MainCorpus.java	(revision 2947)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/MainCorpus.java	(revision 2948)
@@ -388,64 +388,9 @@
 		return 1;
 	}
 	
-	/**
-	 * Gets the properties available in this corpus.
-	 * 
-	 * @return the properties
-	 * 
-	 * @throws CqiClientException
-	 *             the cqi client exception
-	 */
-	@Override
-	public List<WordProperty> getProperties() throws CqiClientException {
-		if (this.lexicalUnitsProperties != null) {
-			return this.lexicalUnitsProperties;
-		}
-		
-		String[] propertiesName;
-		try {
-			propertiesName = CQPSearchEngine.getCqiClient().corpusPositionalAttributes(this.pID);
-		}
-		catch (Exception e) {
-			throw new CqiClientException(e);
-		}
-		
-		List<WordProperty> properties = new ArrayList<>(propertiesName.length);
-		for (int i = 0; i < propertiesName.length; i++) {
-			properties.add(new WordProperty(propertiesName[i], this));
-		}
-		this.lexicalUnitsProperties = properties;
-		return properties;
-	}
-	
 	/*
 	 * (non-Javadoc)
 	 * @see
-	 * org.txm.searchengine.cqp.corpus.Corpus#getProperty(java.lang.
-	 * String)
-	 */
-	@Override
-	public WordProperty getProperty(String name) throws CqiClientException {
-		if (this.lexicalUnitsProperties == null) {
-			getProperties();
-		}
-		
-		int idx = name.indexOf(".");
-		if (idx > 0) { // the name if a qualified name
-			name = name.substring(idx + 1);
-		}
-		
-		for (WordProperty property : this.lexicalUnitsProperties) {
-			if (property.getName().equals(name)) {
-				return property;
-			}
-		}
-		return null;
-	}
-	
-	/*
-	 * (non-Javadoc)
-	 * @see
 	 * org.txm.searchengine.cqp.corpus.CqpObject#getQualifiedCqpId()
 	 */
 	@Override
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Property.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Property.java	(revision 2947)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Property.java	(revision 2948)
@@ -74,7 +74,7 @@
 	 * @return the qualified name
 	 */
 	public String getQualifiedName() {
-		return this.corpus.getCqpId() + "." + this.getFullName(); //$NON-NLS-1$
+		return this.corpus.getMainCorpus().getCqpId() + "." + this.getFullName(); //$NON-NLS-1$
 	}
 	
 	/**
@@ -158,7 +158,8 @@
 		String[] split = str.split(TXMPreferences.LIST_SEPARATOR);
 		for (String s : split) {
 			try {
-				Property p = corpus.getProperty(s);
+				Property p = corpus.getProperty(s); // manage all Property implementations : Word, StructuralUnits and Virtual
+				
 				if (p != null) {
 					properties.add(p);
 				}
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Subcorpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Subcorpus.java	(revision 2947)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Subcorpus.java	(revision 2948)
@@ -279,27 +279,7 @@
 			return 0;
 		}
 	}
-	
-	/*
-	 * (non-Javadoc)
-	 * @see org.txm.searchengine.cqp.corpus.Corpus#getProperties()
-	 */
-	@Override
-	public List<WordProperty> getProperties() throws CqiClientException {
-		return getMainCorpus().getProperties();
-	}
-	
-	/*
-	 * (non-Javadoc)
-	 * @see
-	 * org.txm.searchengine.cqp.corpus.Corpus#getProperty(java.lang.
-	 * String)
-	 */
-	@Override
-	public WordProperty getProperty(String name) throws CqiClientException {
-		return getMainCorpus().getProperty(name);
-	}
-	
+		
 	// protected void finalize() throws Throwable {
 	// try {
 	// //
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/LengthProperty.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/LengthProperty.java	(revision 0)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/LengthProperty.java	(revision 2948)
@@ -0,0 +1,136 @@
+package org.txm.searchengine.cqp.corpus;
+
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
+import java.util.TreeSet;
+
+import org.txm.searchengine.cqp.CQPSearchEngine;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+import org.txm.searchengine.cqp.clientExceptions.UnexpectedAnswerException;
+import org.txm.searchengine.cqp.serverException.CqiServerError;
+
+/**
+ * A CQP property at token/word level
+ * 
+ * @author mdecorde
+ *
+ */
+public class LengthProperty extends VirtualProperty {
+	
+	/**
+	 * Creates a new WordProperty.
+	 * 
+	 * @param name
+	 * @param corpus
+	 */
+	public LengthProperty(CQPCorpus corpus) {
+		super("length", corpus);
+	}
+	
+	public String cpos2Str(int position) {
+		
+		try {
+			String[] rez = CQPSearchEngine.getCqiClient().cpos2Str(corpus.getWordProperty().getQualifiedName(), new int[] {position});
+			return Integer.toString(rez[0].length());
+		} catch (Exception e) {
+			return "0";
+		}
+	}
+	
+	public List<String> getValues(int[] positions) {
+		return Arrays.asList(cpos2Str(positions));
+	}
+	
+	public String[] cpos2Str(int[] positions) {
+		try {
+			String[] rez = CQPSearchEngine.getCqiClient().cpos2Str(corpus.getWordProperty().getQualifiedName(), positions);
+			for (int i = 0 ; i < rez.length ; i++) {
+				rez[i] = Integer.toString(rez[i].length());
+			}
+			return rez;
+		} catch (Exception e) {
+			return new String[positions.length];
+		}
+	}
+
+	@Override
+	public int[] cpos2Id(int[] positions) {
+		try {
+			String[] tmp = CQPSearchEngine.getCqiClient().cpos2Str(corpus.getWordProperty().getQualifiedName(), positions);
+			int[] rez = new int[tmp.length];
+			for (int i = 0 ; i < rez.length ; i++) {
+				rez[i] = tmp[i].length();
+			}
+			return rez;
+		} catch (Exception e) {
+			return new int[positions.length];
+		}
+	}
+
+	@Override
+	public int cpos2Id(int position) {
+		return cpos2Id(new int[] {position})[0];
+	}
+	
+	@Override
+	public String[] id2Str(int[] indices) {
+		String[] rez = new String[indices.length];
+		for (int i = 0 ; i < rez.length ; i++) {
+			rez[i] = Integer.toString(indices[i]);
+		}
+		return rez;
+	}
+
+	@Override
+	public String id2Str(int indice) {
+		return Integer.toString(indice);
+	}
+
+	@Override
+	public String getCQLTest(String value) {
+		try {
+			int l = Integer.parseInt(value);
+			StringBuilder sb = new StringBuilder();
+			sb.append("word=\"");
+			for (int i = 0 ; i < l ; i++) {
+				sb.append(".");
+			}
+			sb.append("\"");
+			return sb.toString();
+		} catch(Exception e) {
+			
+		}
+		return null;
+	}
+
+	@Override
+	public String getCQLTest(List<String> values) {
+		try {
+			TreeSet<String> hash = new TreeSet<>();
+			StringBuilder sb = new StringBuilder();
+			for (String value : values) {
+				int l = Integer.parseInt(value);
+				
+				sb.setLength(0);
+				for (int i = 0 ; i < l ; i++) {
+					sb.append(".");
+				}
+				hash.add(sb.toString());
+			}
+			
+			sb.setLength(0);
+			sb.append("word=\"");
+			for (String dots : hash) {
+				sb.append(dots);
+			}
+			sb.append("\"");
+			return sb.toString();
+		} catch(Exception e) {
+			
+		}
+		return null;
+	}
+}
+

Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/VirtualProperty.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/VirtualProperty.java	(revision 2947)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/VirtualProperty.java	(revision 2948)
@@ -1,6 +1,5 @@
 package org.txm.searchengine.cqp.corpus;
 
-import java.util.ArrayList;
 import java.util.List;
 
 /**
@@ -9,7 +8,7 @@
  * @author mdecorde
  *
  */
-public class VirtualProperty extends Property {
+public abstract class VirtualProperty extends WordProperty {
 	
 	/**
 	 * Creates a new WordProperty.
@@ -23,37 +22,31 @@
 	
 	@Override
 	public String getFullName() {
-		return "<" + getName() + ">";
+		return "(" + getName() + ")";
 	}
 	
-	/**
-	 * Creates a readable formated string from the specified properties list.
-	 * 
-	 * @param properties
-	 * @return
-	 */
-	public static String asString(List<VirtualProperty> properties) {
-		
-		String str = "";
-		for (int i = 0; i < properties.size(); i++) {
-			if (i > 0) {
-				str += "_";
-			}
-			str += properties.get(i).getFullName();
-		}
-		return "@" + str;
-	}
+	public abstract String cpos2Str(int position);
 	
-	public String getValue(int position) {
-		return Integer.toString(position);
+	public abstract String[] cpos2Str(int[] positions);
+	
+	public abstract int[] cpos2Id(int[] allpositionsarray);
+	
+	public abstract int cpos2Id(int position);
+
+	public abstract String[] id2Str(int[] indices);
+	
+	public abstract String id2Str(int indice);
+	
+	public String toString() {
+		return getFullName();
 	}
+
+	public static boolean isAVirtualPropertyFullName(String name) {
+		return name != null && name.startsWith("(") && name.endsWith(")")&& name.length() > 2 ;
+	}
 	
-	public List<String> getValues(int[] positions) {
-		ArrayList<String> rez = new ArrayList<>();
-		for (int p : positions) {
-			rez.add(getValue(p));
-		}
-		return rez;
+	public static String fullnameToName(String fullname) {
+		return fullname.substring(1, fullname.length() - 1);
 	}
 }
 
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/ReferencePattern.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/ReferencePattern.java	(revision 2947)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/ReferencePattern.java	(revision 2948)
@@ -65,10 +65,7 @@
 			
 			String[] split = v.split("\t");
 			for (String s : split) {
-				if (s.startsWith("<") && s.endsWith(">")) {
-					props.addProperty(corpus.getVirtualProperty(s));
-				}
-				else if (s.contains("_")) {
+				if (s.contains("_")) {
 					String[] split2 = s.split("_", 2);
 					StructuralUnit su = corpus.getStructuralUnit(split2[0]);
 					if (su != null) {
@@ -184,14 +181,9 @@
 		String title = ""; //$NON-NLS-1$
 		for (Property p : this.properties) {
 			if (p == null) continue;
-			if (p instanceof StructuralUnitProperty) {
-				StructuralUnitProperty sp = (StructuralUnitProperty) p;
-				title += sp.getFullName() + ", "; //$NON-NLS-1$
+			if (p instanceof StructuralUnitProperty || p instanceof VirtualProperty) {
+				title += p.getFullName() + ", "; //$NON-NLS-1$
 			}
-			else if (p instanceof VirtualProperty) {
-				VirtualProperty sp = (VirtualProperty) p;
-				title += sp.getFullName() + ", "; //$NON-NLS-1$
-			}
 			else {
 				title += p.getName() + ", "; //$NON-NLS-1$
 			}
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/AbstractCqiClient.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/AbstractCqiClient.java	(revision 2947)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/AbstractCqiClient.java	(revision 2948)
@@ -46,6 +46,7 @@
 import org.txm.searchengine.cqp.corpus.QueryResult;
 import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
 import org.txm.searchengine.cqp.corpus.VirtualProperty;
+import org.txm.searchengine.cqp.corpus.WordProperty;
 import org.txm.searchengine.cqp.corpus.query.CQLQuery;
 import org.txm.searchengine.cqp.corpus.query.Match;
 import org.txm.searchengine.cqp.serverException.CqiCqpErrorNoSuchCorpus;
@@ -115,18 +116,14 @@
 	public List<String> getSingleData(Property prop, int[] positions) throws UnexpectedAnswerException, IOException, CqiServerError {
 		String qname = prop.getQualifiedName();
 		AbstractCqiClient cqiClient = CorpusManager.getCorpusManager().getCqiClient();
-		if (prop instanceof VirtualProperty) {
-			return ((VirtualProperty) prop).getValues(positions);
-			
-		}
-		else if (prop instanceof StructuralUnitProperty) {
+		if (prop instanceof StructuralUnitProperty) {
 			int[] strucs = cqiClient.cpos2Struc(qname, positions);
 			return Arrays.asList(cqiClient.struc2Str(qname, strucs));
-			
 		}
-		else {
+		else if (prop instanceof WordProperty) {
 			return Arrays.asList(cqiClient.cpos2Str(qname, positions));
 		}
+		return null;
 	}
 	
 	public List<List<String>> getData(Property prop, List<Integer> positions,
@@ -156,17 +153,15 @@
 		
 		// get values for positions
 		String[] values;
-		if (prop instanceof VirtualProperty) {
-			values = ((VirtualProperty) prop).getValues(cpos).toArray(new String[cpos.length]);
-		}
-		else if (prop instanceof StructuralUnitProperty) {
+		if (prop instanceof StructuralUnitProperty) {
 			String qname = ((StructuralUnitProperty) prop).getQualifiedName();
 			int[] structs = this.cpos2Struc(qname, cpos);
 			values = this.struc2Str(qname, structs);
 		}
-		else {
-			String qname = prop.getQualifiedName();
-			values = this.cpos2Str(qname, cpos);
+		else if (prop instanceof WordProperty) {
+			values = ((WordProperty)prop).cpos2Str(cpos);
+		} else {
+			return null;
 		}
 		
 		// sort results by position
